@make(ais)
@aiInfo(topic=<A task without dependents can be completed but not terminated>,
number=[AI-00441/06],
classcode=[ra],
statuscode=[WJ],
mainref=[09.04@\(06)],
date=[88-05-23])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class ramification 86-07-10
!status approved by WG9/AJPO 88-02-05
@end(toplines)
!status approved by Director, AJPO 88-02-05
!status approved by WG9/Ada Board 87-12-07
!status approved by Ada Board 87-07-30
!status panel/committee-approved (10-0-3) 87-02-17 (by ballot)
!status panel/committee-approved (8-1-1) 86-11-13 (pending letter ballot)
!status work-item 86-08-12
!status received 86-07-10
@references[!references @CommentNum[83-00775]83-00775]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 87-01-19]

A task that has no dependent tasks can be completed but not yet terminated,
i.e., T'@|CALLABLE can be FALSE when T'@|TERMINATED is not yet TRUE.

@subheading[!question 86-12-18]

9.4(6) says:
@begin(quotation)
If a task  has no  dependent task, its termination takes  place
when  it  has  completed  its  execution.  @ellipsis()  If  a  task has
dependent tasks, its termination takes place when the execution
of the  task  is completed  and all  dependent  tasks are term-
inated.
@end(quotation)
For a task with no dependents, does the use of @dq{when} imply that termination
takes place at the same time as completion?  In particular, if a task without
dependents is aborted, is it possible for T'@|CALLABLE to be FALSE and
T'@|TERMINATED also to be FALSE?

@subheading[!response 87-12-07]

In 9.4(6), @dq{when} specifies a condition that is to be satisfied, not a time
at which an action occurs.  In particular, since completion and termination
are distinct states of a task (as is indicated by the rule for tasks that
have dependents), there is no reason to read the rules as specifying that the
transition between these states takes place @dq{instantaneously} when the
specified conditions are satisfied.  In general, a task need not be
terminated as soon as the conditions for termination are satisfied.  In
short, it is possible for a task without dependents to be completed but not
yet terminated, i.e., T'@|TERMINATED can be FALSE even though T'@|CALLABLE is
FALSE.  This is especially the case if a task is aborted while engaged in a
rendezvous with the caller.

